program TestWriteReadSemaphore;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, Interfaces,
  { you can add units after this }
  ThreadTest, FavSemaphore;

var F, G: Integer;
    READ_COUNT: Integer;
    WRITE_COUNT: Integer;
    MY_MUTEX: TFavMutexDebug;

begin
  READ_COUNT := 0;
  FavLogToConsole('This program will create many reader and writer threads and check class TFavWriterReaderSemaphoreWriterPriority');

  MY_GLOBAL_SEMAPHORE := TFavWriterReaderSemaphoreWriterPriority.Create('MYTEST', 'INITIAL');
  MY_MUTEX := TFavMutexDebug.Create('MY_MUTEX', 'Main');

  for F := 0 to CONST_READER_COUNT-1 do begin
    MY_READERS[F] := TThreadTestWriteReadSemaphore.Create(F, MY_GLOBAL_SEMAPHORE, True, True);
  end;
  for F := 0 to CONST_WRITER_COUNT-1 do begin
    MY_WRITERS[F] := TThreadTestWriteReadSemaphore.Create(F, MY_GLOBAL_SEMAPHORE, False, True);
  end;

  for F := 0 to CONST_READER_COUNT-1 do begin
    MY_READERS[F].Start;
  end;
  for F := 0 to CONST_WRITER_COUNT-1 do begin
    MY_WRITERS[F].Start;
  end;

  for G := 0 to 6 do begin
    MY_MUTEX.Wait('Start');
    try
      //MY_MUTEX.Wait('Start');

    except
      on E: Exception do begin
        raise
      end;
    end;
    FavLogToConsole('******************************************************');
    FavLogToConsole('Second: ' + IntToStr(G));
    FavLogToConsole('******************************************************');
    for F := 0 to CONST_READER_COUNT-1 do begin
      with MY_READERS[F] do begin
        FavLogToConsole('Reader: ' + ', with ID: ' + IntToStr(_ThreadID) + ', have value: ' + IntToStr(_Value) + ' and counter is ' + IntToStr(_Counter));
      end;
    end;
    for F := 0 to CONST_WRITER_COUNT-1 do begin
      with MY_WRITERS[F] do begin
        FavLogToConsole('Writer: ' + ', with ID: ' + IntToStr(_ThreadID) + ', have value: ' + IntToStr(_Value) + ' and counter is ' + IntToStr(_Counter));
      end;
    end;
    // no need for this because FAV_THREAD_SYNC_OBJECT will do it
    (*
    if FAV_SYNCOBJECT_STATUS <> nil then begin
      FAV_SYNCOBJECT_STATUS.DumpToFile;
    end;
    *)
    MY_MUTEX.Release('Stop');
    Sleep(1000);
  end;

  // Suspend all writters and receivers so I can make final counters
  for F := 0 to CONST_WRITER_COUNT-1 do begin
    MY_WRITERS[F].ShutDownThread;
  end;
  for F := 0 to CONST_READER_COUNT-1 do begin
    MY_READERS[F].ShutDownThread;
  end;

  WRITE_COUNT := 0;
  for F := 0 to CONST_WRITER_COUNT-1 do begin
    WRITE_COUNT := WRITE_COUNT + MY_WRITERS[F]._Counter;
  end;

  READ_COUNT := 0;
  for F := 0 to CONST_READER_COUNT-1 do begin
    READ_COUNT := READ_COUNT + MY_READERS[F]._Counter;
  end;

  //WRITE_COUNT := 0;
  for F := 0 to CONST_WRITER_COUNT-1 do begin
    //WRITE_COUNT := WRITE_COUNT + MY_WRITERS[F]._Counter;
    FreeAndNil(MY_WRITERS[F]);
  end;

  //READ_COUNT := 0;
  for F := 0 to CONST_READER_COUNT-1 do begin
    //READ_COUNT := READ_COUNT + MY_READERS[F]._Counter;
    FreeAndNil(MY_READERS[F]);
  end;

  FreeAndNil(MY_MUTEX);
  FreeAndNil(MY_GLOBAL_SEMAPHORE);

  FavLogToConsole('Number of readers:' + IntToStr(CONST_READER_COUNT) + '; Number of writters: ' + IntToStr(CONST_WRITER_COUNT));
  FavLogToConsole('END. Cnt of reads (summary): ' + IntToStr(READ_COUNT) + '; Cnt of writes (summary): ' + IntToStr(MY_GLOBAL_VALUE));

  Readln;


end.

